This service will be undergoing maintenance at 00:00 UTC, 2016-09-28. It is expected to last about 1 hours

Bug 682704

Summary: Review Request: uwsgi - Fast, self-healing, application container server
Product: [Fedora] Fedora Reporter: Oskari Saarenmaa <oskari>
Component: Package ReviewAssignee: Nobody's working on this, feel free to take it <nobody>
Status: CLOSED DUPLICATE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: unspecified    
Version: rawhideCC: esm, ewoud+redhat, fedora-package-review, fschwarz, ian, kad, notting, smilner
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2012-02-23 02:08:16 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Attachments:
Description Flags
mod_uwsgi spec file none

Description Oskari Saarenmaa 2011-03-07 05:46:43 EST
Spec URL: http://rpm.taisia.fi/custom/fedora/uwsgi.spec
SRPM URL: http://rpm.taisia.fi/custom/fedora/uwsgi-0.9.6.8-1.fc14.src.rpm
Description:
uWSGI is a fast (pure C), self-healing, developer/sysadmin-friendly
application container server.  Born as a WSGI-only server, over time it has
evolved in a complete stack for networked/clustered web applications,
implementing message/object passing, caching, RPC and process management.
It uses the uwsgi (all lowercase, already included by default in the Nginx
and Cherokee releases) protocol for all the networking/interprocess
communications.  Can be run in preforking mode, threaded,
asynchronous/evented and supports various form of green threads/coroutine
(like uGreen and Fiber).  Sysadmin will love it as it can be configured via
command line, environment variables, xml, .ini and yaml files and via LDAP.
Being fully modular can use tons of different technology on top of the same
core.
Comment 1 Oskari Saarenmaa 2011-03-07 05:47:30 EST
This is my first package, and I need a sponsor.
Comment 2 Steve Milner 2011-05-06 21:20:04 EDT
Thank you for submitting this package for review! I've been waiting for someone to be interested in taking it on.

Some prereview data:
* New version has been released since originally posted
* SRPM builds fine on x86_64.
* rpmlint output. Only possible issue is the line ending whicah can be fixed with %{__sed} -i 's/\r//' uwsgi-wiki-doc*.txt:
$ rpmlint /home/steve/rpmbuild/RPMS/x86_64/uwsgi-0.9.6.8-1.fc14.x86_64.rpm
uwsgi.x86_64: W: spelling-error %description -l en_US interprocess -> inter process, inter-process, interpreters
uwsgi.x86_64: W: spelling-error %description -l en_US preforking -> preforming, preform, preferring
uwsgi.x86_64: W: spelling-error %description -l en_US evented -> evened, vented, e vented
uwsgi.x86_64: W: spelling-error %description -l en_US coroutine -> co routine, co-routine, subroutine
uwsgi.x86_64: W: spelling-error %description -l en_US uGreen -> u Green, Green, green
uwsgi.x86_64: W: spelling-error %description -l en_US xml -> XML, cml, ml
uwsgi.x86_64: W: spelling-error %description -l en_US ini -> uni, in, ii
uwsgi.x86_64: W: spelling-error %description -l en_US yaml -> yam, amyl, yams
uwsgi.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/uwsgi-0.9.6.8/uwsgi-wiki-doc-v15.txt
uwsgi.x86_64: W: no-manual-page-for-binary uwsgi
1 packages and 0 specfiles checked; 0 errors, 10 warnings.
* Sources match:
4a9b8bef52e2ff60fab645d595d1128e  ../SOURCES/uwsgi-0.9.6.8.tar.gz
4a9b8bef52e2ff60fab645d595d1128e  uwsgi-0.9.6.8.tar.gz

I think it would be very helpful to add a subpackage or a sibling package for the apache2 uwsgi module. For the heck of it I'm attaching a sibling package spec based on yours :-).

Thanks for working on this package, and good luck with the review!
Comment 3 Steve Milner 2011-05-06 21:22:45 EDT
Created attachment 497471 [details]
mod_uwsgi spec file

mod_uwsgi spec for completeness.
Comment 4 Jorge A Gallegos 2011-07-24 03:52:06 EDT
Hi,

I'm sorry if this looks as if I'm hijacking this ticket, it is not. I just came upon it right at the time I wanted to start packaging uwsgi by myself. I've taken Oskari's original spec and put some more work on top of it, hope Oskari finds it useful.
I've also updated it to the most current stable version (0.9.8.3) and split the package using a plugin approach (as suggested by uwsgi).
There's a problem, sorta. At some point between 0.9.6 and 0.9.8 there was a change in the make process (I haven't been able to pinpoint it) resulting in the following warning when trying to rpmbuild:

ERROR   0001: file '/usr/sbin/uwsgi' contains a standard rpath '/usr/lib64' in [/usr/lib64]

(and so on for all the .so binaries produced, actually). This means the package doesn't pass the check-rpaths step, you have then to build like this:

QA_RPATHS=$[ 0x0001|0x0010 ] rpmbuild -ba uwsgi-0.9.8.3-1.fc15.src.rpm

Please if someone could actually take a look at Oskari's work there's more of us who want to see uwsgi in the fedora repos, my modifications are in http://kad.fedorapeople.org/packages/uwsgi/ but all credit goes to him for tackling uwsgi first :)

Cheers
Comment 5 Jorge A Gallegos 2011-08-14 18:48:01 EDT
Ok so thanks to Mamoru I could pinpoint the rpath issue, I uploaded a new spec/srpm, they are available here:

http://kad.fedorapeople.org/packages/uwsgi/uwsgi-0.9.8.3-2.fc15.src.rpm
http://kad.fedorapeople.org/packages/uwsgi/uwsgi.spec
Comment 6 Jorge A Gallegos 2011-08-21 19:06:59 EDT
While reviewing other package requests I realized I could improve this one (this method works it seems), so I uploaded a new version:

http://kad.fedorapeople.org/packages/uwsgi/uwsgi-0.9.8.3-3.fc15.src.rpm
http://kad.fedorapeople.org/packages/uwsgi/uwsgi.spec
Comment 7 Ed Marshall 2011-09-03 18:48:32 EDT
Just a note: running "uwsgi --plugin XYZ" won't work unless XYZ_plugin.so is in the current working directory, because the plugin path doesn't get set at build-time (so it defaults to "./").

I added this to %prep to get that part working correctly:

echo "plugin_dir = %{_libdir}/uwsgi" >> buildconf/fedora.ini

After that, I patched build_plugin uwsgiconfig.py to not include plugin_dir + '/' when specifying the destination for the built module (plugin_dest); otherwise, it tries to build and install it directly to the target location (ie. outside the buildroot). A better long-term fix here would be adding support for a buildroot to uwsgi's build system.
Comment 8 Jorge A Gallegos 2011-10-09 20:41:43 EDT
My god, you are correct. I just addressed that and upgraded to the latest stable version from upstream (which includes two patched I'd sent to work with fedora :)

Here are the links:

http://kad.fedorapeople.org/packages/uwsgi/uwsgi-0.9.9.2-2.fc15.src.rpm
http://kad.fedorapeople.org/packages/uwsgi/uwsgi.spec

I successfully submitted a koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=3418505
Comment 9 Michael Schwendt 2011-11-23 15:22:31 EST
One problem I see here is one cannot sponsor the initial submitter (= Oskari) based on the work done on the src.rpm by somebody else (= Jorge). Oskari has not left any comment since opening this ticket.

The better choice would have been for Jorge to open a separate package review request for "uwsgi", linking/referring to this one, which may be a dead end eventually.
Comment 10 Jorge A Gallegos 2012-01-23 21:46:51 EST
Opened a new ticket here https://bugzilla.redhat.com/show_bug.cgi?id=784156 as per Michael's suggestion. Also updated to latest version
Comment 11 Jorge A Gallegos 2012-02-23 02:08:16 EST
Ok, package review was finished and package was accepted, closing this one as duplicate.

*** This bug has been marked as a duplicate of bug 784156 ***